This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 787712 - Threaded python code deadlocks when calling subprocess.Popen()
Threaded python code deadlocks when calling subprocess.Popen()
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: python (Show other bugs)
16
x86_64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Dave Malcolm
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-02-06 10:25 EST by Simon Farnsworth
Modified: 2013-02-13 20:10 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-13 20:10:08 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Patch applied to the F17 SRPM to make Python work again (2.05 KB, patch)
2012-02-07 10:00 EST, Simon Farnsworth
no flags Details | Diff

  None (edit)
Description Simon Farnsworth 2012-02-06 10:25:23 EST
Description of problem:

We have multithreaded Python code, using the threading module - we call subprocess.Popen() to create new processes. It's deadlocking in Python's posix_fork when it tries to reinitialise the GIL.

http://bugs.python.org/issue13817 refers to the same problem, and http://bugs.python.org/msg152474 lists the fix commits to currently maintained branches.

We're going to patch Python ourselves to fix this, but would appreciate it if Fedora would pick up the upstream fix.

We see the problem in python binaries built from python-2.7.2-5.2.fc16.src.rpm
Comment 1 Simon Farnsworth 2012-02-07 10:00:51 EST
Created attachment 559976 [details]
Patch applied to the F17 SRPM to make Python work again

For my fix, I applied the attached patch to the F17 python from Koji:

http://koji.fedoraproject.org/koji/buildinfo?buildID=281149

This fixes the bug for me.
Comment 2 Warren Togami 2012-05-02 07:27:25 EDT
The python F17 changelog says:

* Sat Feb 25 2012 Thomas Spura <tomspur@fedoraproject.org> - 2.7.2-20
- fix deadlock issue (#787712)

Does this mean this is fixed?
Comment 3 Fedora End Of Life 2013-01-16 17:37:19 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Fedora End Of Life 2013-02-13 20:10:12 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.